"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stmt_matcher = exports.stmts_matcher = exports.exp_matcher = void 0;
const Exp = __importStar(require("../exp"));
const Stmt = __importStar(require("../stmt"));
const pt = __importStar(require("../../partech"));
function exp_matcher(tree) {
    return pt.Tree.matcher({
        "exp:var": ({ name }) => Exp.v(pt.Tree.str(name)),
        "exp:fn": ({ name, body }) => Exp.fn(pt.Tree.str(name), exp_matcher(body)),
        "exp:ap": ({ target, args }) => {
            let exp = Exp.v(pt.Tree.str(target));
            for (const arg of pt.matchers.one_or_more_matcher(args)) {
                exp = Exp.ap(exp, exp_matcher(arg));
            }
            return exp;
        },
        "exp:begin": ({ stmts, ret }) => Exp.begin(stmts_matcher(stmts), exp_matcher(ret)),
    })(tree);
}
exports.exp_matcher = exp_matcher;
function stmts_matcher(tree) {
    return pt.Tree.matcher({
        "stmts:stmts": ({ stmts }) => pt.matchers.zero_or_more_matcher(stmts).map(stmt_matcher),
    })(tree);
}
exports.stmts_matcher = stmts_matcher;
function stmt_matcher(tree) {
    return pt.Tree.matcher({
        "stmt:def": ({ name, exp }) => Stmt.def(pt.Tree.str(name), exp_matcher(exp)),
        "stmt:show": ({ exp }) => Stmt.show(exp_matcher(exp)),
    })(tree);
}
exports.stmt_matcher = stmt_matcher;
