"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.builder = exports.description = exports.aliases = exports.command = void 0;
const Exp = __importStar(require("../../exp"));
const Stmt = __importStar(require("../../stmt"));
const frontend = __importStar(require("../../frontend"));
const Ctx = __importStar(require("../../ctx"));
const Env = __importStar(require("../../env"));
const Trace = __importStar(require("../../../trace"));
const pt = __importStar(require("../../../partech"));
const fs_1 = __importDefault(require("fs"));
const strip_ansi_1 = __importDefault(require("strip-ansi"));
exports.command = "eval <input>";
exports.aliases = ["$0"];
exports.description = "Eval a file";
exports.builder = {
    nocolor: { type: "boolean", default: false },
};
exports.handler = async (argv) => {
    const text = fs_1.default.readFileSync(argv.input, { encoding: "utf-8" });
    try {
        const stmts = frontend.parse_stmts(text);
        const ctx = Ctx.init();
        const env = Env.init();
        for (const stmt of stmts) {
            Stmt.run(ctx, env, stmt);
        }
    }
    catch (error) {
        if (error instanceof Trace.Trace) {
            const trace = error;
            console.error(Trace.repr(trace, Exp.repr));
            process.exit(1);
        }
        if (error instanceof pt.ParsingError) {
            let message = error.message;
            message += "\n";
            message += pt.Span.report(error.span, text);
            console.error(argv.nocolor ? strip_ansi_1.default(message) : message);
            process.exit(1);
        }
        else {
            throw error;
        }
    }
};
