export declare const zero_or_more: {
    $fn: (string | {
        "zero_or_more:zero": never[];
        "zero_or_more:more": ({
            head: string;
            tail?: undefined;
        } | {
            tail: {
                $ap: string[];
            };
            head?: undefined;
        })[];
    })[];
};
export declare const one_or_more: {
    $fn: (string | {
        "one_or_more:one": {
            value: string;
        }[];
        "one_or_more:more": ({
            head: string;
            tail?: undefined;
        } | {
            tail: {
                $ap: string[];
            };
            head?: undefined;
        })[];
    })[];
};
export declare const dashline: {
    "dashline:dashline": (string | {
        $ap: string[];
    })[];
};
export declare const identifier: {
    $pattern: string[];
};
export declare const exp: {
    "exp:var": {
        name: string;
    }[];
    "exp:fn": (string | {
        name: string;
        body?: undefined;
    } | {
        body: string;
        name?: undefined;
    })[];
    "exp:ap": ({
        target: string;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        target?: undefined;
    })[];
    "exp:begin": (string | {
        stmts: string;
        ret?: undefined;
    } | {
        ret: string;
        stmts?: undefined;
    })[];
    "exp:zero": string[];
    "exp:add1": (string | {
        prev: string;
    })[];
    "exp:number": {
        value: {
            $pattern: string[];
        };
    }[];
    "exp:rec": (string | {
        t: string;
        target?: undefined;
        base?: undefined;
        step?: undefined;
    } | {
        target: string;
        t?: undefined;
        base?: undefined;
        step?: undefined;
    } | {
        base: string;
        t?: undefined;
        target?: undefined;
        step?: undefined;
    } | {
        step: string;
        t?: undefined;
        target?: undefined;
        base?: undefined;
    })[];
    "exp:deduction": (string | {
        deduction_entries: {
            $ap: string[];
        };
        deduction_args?: undefined;
    } | {
        deduction_args: {
            $ap: string[];
        };
        deduction_entries?: undefined;
    })[];
};
export declare const deduction_entry: {
    "deduction_entry:deduction_entry": (string | {
        t: string;
        exp?: undefined;
    } | {
        exp: string;
        t?: undefined;
    })[];
};
export declare const ty: {
    "ty:nat": string[];
    "ty:arrow": (string | {
        arg_t: string;
        ret_t?: undefined;
    } | {
        ret_t: string;
        arg_t?: undefined;
    })[];
};
export declare const stmts: {
    "stmts:stmts": {
        stmts: {
            $ap: string[];
        };
    }[];
};
export declare const stmt: {
    "stmt:def": (string | {
        name: string;
        exp?: undefined;
    } | {
        exp: string;
        name?: undefined;
    })[];
    "stmt:claim": (string | {
        claim: string;
        t?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        t: string;
        claim?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        define: string;
        claim?: undefined;
        t?: undefined;
        exp?: undefined;
    } | {
        exp: string;
        claim?: undefined;
        t?: undefined;
        define?: undefined;
    })[];
    "stmt:show": (string | {
        exp: string;
    })[];
};
