"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stmt = exports.stmts = exports.ty = exports.deduction_entry = exports.exp = exports.identifier = exports.dashline = exports.one_or_more = exports.zero_or_more = void 0;
const pt = __importStar(require("../../partech"));
exports.zero_or_more = pt.grammars.zero_or_more;
exports.one_or_more = pt.grammars.one_or_more;
exports.dashline = pt.grammars.dashline;
const preserved = ["zero", "add1", "rec"];
exports.identifier = {
    $pattern: ["identifier", `^(?!(${preserved.join("|")}))`],
};
exports.exp = {
    "exp:var": [{ name: "identifier" }],
    "exp:fn": [
        '"("',
        { name: "identifier" },
        '")"',
        '"="',
        '">"',
        { body: "exp" },
    ],
    "exp:ap": [
        { target: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
    "exp:begin": ['"{"', { stmts: "stmts" }, { ret: "exp" }, '"}"'],
    "exp:zero": ['"zero"'],
    "exp:add1": ['"add1"', '"("', { prev: "exp" }, '")"'],
    "exp:number": [{ value: { $pattern: ["number"] } }],
    "exp:rec": [
        '"rec"',
        '"["',
        { t: "ty" },
        '"]"',
        '"("',
        { target: "exp" },
        '","',
        { base: "exp" },
        '","',
        { step: "exp" },
        '")"',
    ],
    "exp:deduction": [
        '"{"',
        { deduction_entries: { $ap: ["one_or_more", "deduction_entry"] } },
        { deduction_args: { $ap: ["zero_or_more", "exp"] } },
        '"}"',
    ],
};
exports.deduction_entry = {
    "deduction_entry:deduction_entry": [{ t: "ty" }, "dashline", { exp: "exp" }],
};
exports.ty = {
    "ty:nat": ['"Nat"'],
    "ty:arrow": ['"("', { arg_t: "ty" }, '")"', '"-"', '">"', { ret_t: "ty" }],
};
exports.stmts = {
    "stmts:stmts": [{ stmts: { $ap: ["zero_or_more", "stmt"] } }],
};
exports.stmt = {
    "stmt:def": [{ name: "identifier" }, '"="', { exp: "exp" }],
    "stmt:claim": [
        { claim: "identifier" },
        '":"',
        { t: "ty" },
        { define: "identifier" },
        '"="',
        { exp: "exp" },
    ],
    "stmt:show": ['"@"', '"show"', { exp: "exp" }],
};
