"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stmt = exports.stmts = exports.deduction_entry = exports.exp = exports.identifier = exports.dashline = exports.one_or_more = exports.zero_or_more = void 0;
const pt = __importStar(require("../../partech"));
exports.zero_or_more = pt.grammars.zero_or_more;
exports.one_or_more = pt.grammars.one_or_more;
exports.dashline = pt.grammars.dashline;
const preserved = [
    "Pair",
    "cons",
    "car",
    "cdr",
    "Nat",
    "zero",
    "add1",
    "Equal",
    "same",
    "replace",
    "Trivial",
    "sole",
    "Absurd",
    "String",
    "Type",
];
exports.identifier = {
    $pattern: ["identifier", `^(?!(${preserved.join("|")}))`],
};
exports.exp = {
    "exp:var": [{ name: "identifier" }],
    "exp:pi": [
        '"("',
        { name: "identifier" },
        '":"',
        { arg_t: "exp" },
        '")"',
        '"-"',
        '">"',
        { ret_t: "exp" },
    ],
    "exp:arrow": ['"("', { arg_t: "exp" }, '")"', '"-"', '">"', { ret_t: "exp" }],
    "exp:fn": [
        '"("',
        { name: "identifier" },
        '")"',
        '"="',
        '">"',
        { ret: "exp" },
    ],
    "exp:ap": [
        { target: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
    "exp:sigma": [
        '"("',
        { name: "identifier" },
        '":"',
        { car_t: "exp" },
        '")"',
        '"*"',
        { cdr_t: "exp" },
    ],
    "exp:pair": [
        '"Pair"',
        '"("',
        { car_t: "exp" },
        '","',
        { cdr_t: "exp" },
        '")"',
    ],
    "exp:cons": ['"cons"', '"("', { car: "exp" }, '","', { cdr: "exp" }, '")"'],
    "exp:car": ['"car"', '"("', { target: "exp" }, '")"'],
    "exp:cdr": ['"cdr"', '"("', { target: "exp" }, '")"'],
    "exp:nat": ['"Nat"'],
    "exp:zero": ['"zero"'],
    "exp:add1": ['"add1"', '"("', { prev: "exp" }, '")"'],
    "exp:number": [{ value: { $pattern: ["number"] } }],
    "exp:nat_ind": [
        '"Nat"',
        '"."',
        '"ind"',
        '"("',
        { target: "exp" },
        '","',
        { motive: "exp" },
        '","',
        { base: "exp" },
        '","',
        { step: "exp" },
        '")"',
    ],
    "exp:equal": [
        '"Equal"',
        '"("',
        { t: "exp" },
        '","',
        { from: "exp" },
        '","',
        { to: "exp" },
        '")"',
    ],
    "exp:same": ['"same"'],
    "exp:replace": [
        '"replace"',
        '"("',
        { target: "exp" },
        '","',
        { motive: "exp" },
        '","',
        { base: "exp" },
        '")"',
    ],
    "exp:trivial": ['"Trivial"'],
    "exp:sole": ['"sole"'],
    "exp:absurd": ['"Absurd"'],
    "exp:absurd_ind": [
        '"Absurd"',
        '"."',
        '"ind"',
        '"("',
        { target: "exp" },
        '","',
        { motive: "exp" },
        '")"',
    ],
    "exp:str": ['"String"'],
    "exp:quote": [{ value: { $pattern: ["string"] } }],
    "exp:type": ['"Type"'],
    "exp:begin": ['"{"', { stmts: "stmts" }, { ret: "exp" }, '"}"'],
    "exp:deduction": [
        '"{"',
        { deduction_entries: { $ap: ["one_or_more", "deduction_entry"] } },
        { deduction_args: { $ap: ["zero_or_more", "exp"] } },
        '"}"',
    ],
};
exports.deduction_entry = {
    "deduction_entry:deduction_entry": [{ t: "exp" }, "dashline", { exp: "exp" }],
};
exports.stmts = {
    "stmts:stmts": [{ stmts: { $ap: ["zero_or_more", "stmt"] } }],
};
exports.stmt = {
    "stmt:def": [{ name: "identifier" }, '"="', { exp: "exp" }],
    "stmt:claim": [
        { claim: "identifier" },
        '":"',
        { t: "exp" },
        { define: "identifier" },
        '"="',
        { exp: "exp" },
    ],
    "stmt:show": ['"@"', '"show"', { exp: "exp" }],
};
