"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse_stmts = void 0;
const grammars = __importStar(require("./grammars"));
const matchers = __importStar(require("./matchers"));
const pt = __importStar(require("../../partech"));
function parse_stmts(text) {
    const mod = pt.Mod.build(grammars);
    const grammar = pt.Mod.dot(mod, "stmts");
    const parser = pt.EarleyParser.create(grammar);
    const lexer = pt.lexers.common;
    const processed_text = pt.preprocess.erase_comment(text);
    const tokens = processed_text.trim().length === 0 ? [] : lexer.lex(processed_text);
    const tree = parser.parse(tokens);
    const stmts = matchers.stmts_matcher(tree);
    return stmts;
}
exports.parse_stmts = parse_stmts;
