"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check_obj = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Ctx = __importStar(require("../ctx"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
function check_obj(mod, ctx, obj, cls) {
    // NOTE We DO NOT need to update the `ctx` as we go along.
    // - just like checking `Exp.cons`.
    const properties = new Map(obj.properties);
    check_properties_aganst_sat(mod, ctx, properties, cls.sat);
    check_properties_aganst_tel(mod, ctx, properties, cls.tel);
}
exports.check_obj = check_obj;
function check_properties_aganst_sat(mod, ctx, properties, sat) {
    for (const entry of sat) {
        const found = properties.get(entry.name);
        if (found === undefined) {
            throw new Trace.Trace(ut.aline(`
          |Can not found satisfied entry name: ${entry.name}
          |`));
        }
        Exp.check(mod, ctx, found, entry.t);
        const value = Exp.evaluate(mod, Ctx.to_env(ctx), found);
        if (!Value.conversion(mod, ctx, entry.t, value, entry.value)) {
            throw new Trace.Trace(ut.aline(`
          |I am expecting the following two values to be the same ${Exp.repr(Value.readback(mod, ctx, Value.type, entry.t))}.
          |But they are not.
          |The value in object:
          |  ${Exp.repr(Value.readback(mod, ctx, entry.t, value))}
          |The value in partially filled class:
          |  ${Exp.repr(Value.readback(mod, ctx, entry.t, entry.value))}
          |`));
        }
        properties.delete(entry.name);
    }
}
function check_properties_aganst_tel(mod, ctx, properties, tel) {
    if (tel.next === undefined)
        return;
    const next_value = check_properties_aganst_next(mod, ctx, properties, tel.next);
    const filled_tel = Value.Telescope.fill(tel, next_value);
    Exp.check(mod, ctx, Exp.obj(properties), Value.cls([], filled_tel));
}
function check_properties_aganst_next(mod, ctx, properties, next) {
    const found = properties.get(next.name);
    if (found === undefined) {
        throw new Trace.Trace(ut.aline(`
        |Can not found next name: ${next.name}
        |`));
    }
    Exp.check(mod, ctx, found, next.t);
    properties.delete(next.name);
    return Exp.evaluate(mod, Ctx.to_env(ctx), found);
}
