"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check_union_type = void 0;
const Exp = __importStar(require("../exp"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
const exp_check_by_infer_1 = require("./exp-check-by-infer");
function check_union_type(mod, ctx, exp, union) {
    const { left, right } = union;
    try {
        exp_check_by_infer_1.check_by_infer(mod, ctx, exp, union);
    }
    catch (error) {
        if (error instanceof Trace.Trace) {
            try {
                Exp.check(mod, ctx, exp, left);
            }
            catch (error_left) {
                if (error_left instanceof Trace.Trace) {
                    try {
                        Exp.check(mod, ctx, exp, right);
                    }
                    catch (error_right) {
                        if (error_right instanceof Trace.Trace) {
                            throw new Trace.Trace(ut.aline(`
              |Check of both part of union type failed.
              |
              |left: ${ut.indent(error_left.message, "  ")}
              |right: ${ut.indent(error_right.message, "  ")}`));
                        }
                        else {
                            throw error_right;
                        }
                    }
                }
                else {
                    throw error_left;
                }
            }
        }
        else {
            throw error;
        }
    }
}
exports.check_union_type = check_union_type;
