"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = void 0;
const Value = __importStar(require("../value"));
const Trace = __importStar(require("../../trace"));
const exp_check_union_type_1 = require("./exp-check-union-type");
const exp_check_fn_1 = require("./exp-check-fn");
const exp_check_case_fn_1 = require("./exp-check-case-fn");
const exp_check_obj_1 = require("./exp-check-obj");
const exp_check_same_1 = require("./exp-check-same");
const exp_check_quote_1 = require("./exp-check-quote");
const exp_check_begin_1 = require("./exp-check-begin");
const exp_check_by_infer_1 = require("./exp-check-by-infer");
function check(mod, ctx, exp, t) {
    try {
        if (t.kind === "Value.union")
            return exp_check_union_type_1.check_union_type(mod, ctx, exp, t);
        if (exp.kind === "Exp.fn")
            return exp_check_fn_1.check_fn(mod, ctx, exp, Value.is_pi(mod, ctx, t));
        if (exp.kind === "Exp.case_fn")
            return exp_check_case_fn_1.check_case_fn(mod, ctx, exp, Value.is_pi(mod, ctx, t));
        if (exp.kind === "Exp.obj")
            return exp_check_obj_1.check_obj(mod, ctx, exp, Value.is_cls(mod, ctx, t));
        if (exp.kind === "Exp.same")
            return exp_check_same_1.check_same(mod, ctx, exp, Value.is_equal(mod, ctx, t));
        if (exp.kind === "Exp.begin")
            return exp_check_begin_1.check_begin(mod, ctx, exp, t);
        if (exp.kind === "Exp.quote")
            return exp_check_quote_1.check_quote(mod, ctx, exp, t);
        return exp_check_by_infer_1.check_by_infer(mod, ctx, exp, t);
    }
    catch (error) {
        if (error instanceof Trace.Trace) {
            throw Trace.trail(error, exp);
        }
        else {
            throw error;
        }
    }
}
exports.check = check;
