"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.do_ap_not_yet = exports.do_ap_data = exports.do_ap_data_constructor = exports.do_ap_datatype = exports.do_ap_type_constructor = exports.do_ap_cls = exports.do_ap_case_fn = exports.do_ap = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Normal = __importStar(require("../normal"));
const Neutral = __importStar(require("../neutral"));
const Trace = __importStar(require("../../trace"));
function do_ap(target, arg) {
    if (target.kind === "Value.fn")
        return Value.Closure.apply(target.ret_cl, arg);
    if (target.kind === "Value.case_fn")
        return do_ap_case_fn(target, arg);
    if (target.kind === "Value.cls")
        return do_ap_cls(target, arg);
    if (target.kind === "Value.type_constructor")
        return do_ap_type_constructor(target, arg);
    if (target.kind === "Value.datatype")
        return do_ap_datatype(target, arg);
    if (target.kind === "Value.data_constructor")
        return do_ap_data_constructor(target, arg);
    if (target.kind === "Value.data")
        return do_ap_data(target, arg);
    if (target.kind === "Value.not_yet")
        return do_ap_not_yet(target, arg);
    throw new Trace.Trace(Exp.explain_elim_target_mismatch({
        elim: "ap",
        expecting: ["Value.fn", "Value.cls", "Value.not_yet"],
        reality: target.kind,
    }));
}
exports.do_ap = do_ap;
function do_ap_case_fn(case_fn, arg) {
    if (arg.kind === "Value.not_yet") {
        if (arg.t.kind === "Value.pi")
            return Value.not_yet(Value.Closure.apply(arg.t.ret_t_cl, arg), Neutral.match(case_fn, arg.t, arg.neutral));
        throw new Trace.Trace(Exp.explain_elim_target_type_mismatch({
            elim: "match",
            expecting: ["Value.pi"],
            reality: arg.t.kind,
        }));
    }
    for (const ret_cl of case_fn.ret_cls) {
        try {
            return Value.Closure.apply(ret_cl, arg);
        }
        catch (error) {
            if (error instanceof Trace.Trace) {
                // NOTE pass
            }
            else {
                throw error;
            }
        }
    }
    throw new Trace.Trace("case_fn mismatch");
}
exports.do_ap_case_fn = do_ap_case_fn;
function do_ap_cls(cls, arg) {
    if (cls.tel.next === undefined)
        throw new Trace.Trace("cls is full");
    return Value.cls([
        ...cls.sat,
        {
            name: cls.tel.next.name,
            t: cls.tel.next.t,
            value: arg,
        },
    ], Value.Telescope.fill(cls.tel, arg));
}
exports.do_ap_cls = do_ap_cls;
function do_ap_type_constructor(type_constructor, arg) {
    if (type_constructor.t.kind === "Value.pi") {
        const pi = type_constructor.t;
        const remain_t = Value.Closure.apply(pi.ret_t_cl, arg);
        return Value.datatype(type_constructor, [arg], remain_t);
    }
    throw new Trace.Trace("expecting type_constructor.t to be Value.pi");
}
exports.do_ap_type_constructor = do_ap_type_constructor;
function do_ap_datatype(datatype, arg) {
    if (datatype.t.kind === "Value.pi") {
        const pi = datatype.t;
        const remain_t = Value.Closure.apply(pi.ret_t_cl, arg);
        return Value.datatype(datatype.type_constructor, [...datatype.args, arg], remain_t);
    }
    throw new Trace.Trace("expecting datatype.t to be Value.pi");
}
exports.do_ap_datatype = do_ap_datatype;
function do_ap_data_constructor(data_constructor, arg) {
    if (data_constructor.t.kind === "Value.pi") {
        const pi = data_constructor.t;
        const remain_t = Value.Closure.apply(pi.ret_t_cl, arg);
        return Value.data(data_constructor, [arg], remain_t);
    }
    throw new Trace.Trace("expecting data_constructor.t to be Value.pi");
}
exports.do_ap_data_constructor = do_ap_data_constructor;
function do_ap_data(data, arg) {
    if (data.t.kind === "Value.pi") {
        const pi = data.t;
        const remain_t = Value.Closure.apply(pi.ret_t_cl, arg);
        return Value.data(data.data_constructor, [...data.args, arg], remain_t);
    }
    throw new Trace.Trace("expecting data.t to be Value.pi");
}
exports.do_ap_data = do_ap_data;
function do_ap_not_yet(not_yet, arg) {
    if (not_yet.t.kind === "Value.pi")
        return Value.not_yet(Value.Closure.apply(not_yet.t.ret_t_cl, arg), Neutral.ap(not_yet.neutral, Normal.create(not_yet.t.arg_t, arg)));
    throw new Trace.Trace(Exp.explain_elim_target_type_mismatch({
        elim: "ap",
        expecting: ["Value.pi"],
        reality: not_yet.t.kind,
    }));
}
exports.do_ap_not_yet = do_ap_not_yet;
