"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.do_dot_not_yet = exports.do_dot_type_constructor = exports.do_dot_cls = exports.do_dot_obj = exports.do_dot = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Neutral = __importStar(require("../neutral"));
const Trace = __importStar(require("../../trace"));
function do_dot(target, name) {
    if (target.kind === "Value.obj")
        return do_dot_obj(target, name);
    if (target.kind === "Value.cls")
        return do_dot_cls(target, name);
    if (target.kind === "Value.type_constructor")
        return do_dot_type_constructor(target, name);
    if (target.kind === "Value.not_yet")
        return do_dot_not_yet(target, name);
    throw new Trace.Trace(Exp.explain_elim_target_mismatch({
        elim: "dot",
        expecting: ["Value.obj", "Value.cls", "Value.not_yet"],
        reality: target.kind,
    }));
}
exports.do_dot = do_dot;
function do_dot_obj(obj, name) {
    const value = obj.properties.get(name);
    if (value === undefined)
        throw new Trace.Trace(`the property name ${name} is undefined.`);
    return value;
}
exports.do_dot_obj = do_dot_obj;
function do_dot_cls(cls, name) {
    for (const entry of cls.sat) {
        if (entry.name === name) {
            return entry.t;
        }
    }
    return Value.Telescope.dot(cls.tel, name);
}
exports.do_dot_cls = do_dot_cls;
function do_dot_type_constructor(type_constructor, name) {
    const entry = type_constructor.delayed.sums.find(({ tag }) => tag === name);
    if (entry === undefined)
        throw new Trace.Trace(`can not find tag in type_constructor: ${name}`);
    return Value.data_constructor(type_constructor, name, Exp.evaluate(type_constructor.delayed.mod, type_constructor.delayed.env, entry.t));
}
exports.do_dot_type_constructor = do_dot_type_constructor;
function do_dot_not_yet(not_yet, name) {
    if (not_yet.t.kind === "Value.cls")
        return Value.not_yet(Value.Telescope.dot(not_yet.t.tel, name), Neutral.dot(not_yet.neutral, name));
    throw new Trace.Trace(Exp.explain_elim_target_type_mismatch({
        elim: "dot",
        expecting: ["Value.cls"],
        reality: not_yet.t.kind,
    }));
}
exports.do_dot_not_yet = do_dot_not_yet;
