"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.infer_ap = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Ctx = __importStar(require("../ctx"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
function infer_ap(mod, ctx, ap) {
    const target_t = Exp.infer(mod, ctx, ap.target);
    if (target_t.kind === "Value.pi")
        return when_target_is_pi(mod, ctx, target_t, ap);
    if (target_t.kind === "Value.type")
        return when_target_is_type(mod, ctx, ap);
    throw new Trace.Trace(Value.unexpected(mod, ctx, target_t, {
        message: `I am expecting the target_t to be pi or type.`,
    }));
}
exports.infer_ap = infer_ap;
function when_target_is_pi(mod, ctx, pi, ap) {
    Exp.check(mod, ctx, ap.arg, pi.arg_t);
    return Value.Closure.apply(pi.ret_t_cl, Exp.evaluate(mod, Ctx.to_env(ctx), ap.arg));
}
function when_target_is_type(mod, ctx, ap) {
    const target = Exp.evaluate(mod, Ctx.to_env(ctx), ap.target);
    const cls = Value.is_cls(mod, ctx, target);
    if (cls.tel.next === undefined) {
        throw new Trace.Trace(ut.aline(`
        |The telescope of the cls is full.
        |`));
    }
    Exp.check(mod, ctx, ap.arg, cls.tel.next.t);
    return Value.type;
}
