"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.infer_cls = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Ctx = __importStar(require("../ctx"));
function infer_cls(mod, ctx, cls) {
    // NOTE We DO need to update the `ctx` as we go along.
    // - just like inferring `Exp.sigma`.
    ctx = Ctx.clone(ctx);
    go_through_sat(mod, ctx, cls.sat);
    go_through_scope(mod, ctx, cls.scope);
    return Value.type;
}
exports.infer_cls = infer_cls;
function go_through_sat(mod, ctx, sat) {
    for (const entry of sat) {
        Exp.check(mod, ctx, entry.t, Value.type);
        const t = Exp.evaluate(mod, Ctx.to_env(ctx), entry.t);
        Exp.check(mod, ctx, entry.exp, t);
        Ctx.update(ctx, entry.name, t);
    }
}
function go_through_scope(mod, ctx, scope) {
    if (scope.length === 0)
        return;
    const [entry, ...tail] = scope;
    Exp.check(mod, ctx, entry.t, Value.type);
    const t = Exp.evaluate(mod, Ctx.to_env(ctx), entry.t);
    Ctx.update(ctx, entry.name, t);
    go_through_scope(mod, ctx, tail);
}
