"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.infer_type_constructor = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Ctx = __importStar(require("../ctx"));
const Trace = __importStar(require("../../trace"));
function infer_type_constructor(mod, ctx, datatype) {
    check_type_constructor_t(mod, ctx, datatype.t);
    for (const entry of datatype.sums) {
        check_data_constructor_t(mod, ctx, entry.t, datatype.name);
    }
    return Exp.evaluate(mod, Ctx.to_env(ctx), datatype.t);
}
exports.infer_type_constructor = infer_type_constructor;
function check_data_constructor_t(mod, ctx, t, name) {
    if (t.kind === "Exp.pi") {
        const pi = t;
        Exp.check(mod, ctx, pi.arg_t, Value.type);
        check_data_constructor_t(mod, Ctx.extend(ctx, pi.name, Exp.evaluate(mod, Ctx.to_env(ctx), pi.arg_t)), pi.ret_t, name);
        return;
    }
    Exp.check(mod, ctx, t, Value.type);
    const t_value = Exp.evaluate(mod, Ctx.to_env(ctx), t);
    if ((t_value.kind === "Value.type_constructor" && t_value.name === name) ||
        (t_value.kind === "Value.datatype" &&
            t_value.type_constructor.name === name)) {
        return;
    }
    throw new Trace.Trace("the t should be pi or ap of type constructor");
}
function check_type_constructor_t(mod, ctx, t) {
    if (t.kind === "Exp.pi") {
        const pi = t;
        Exp.check(mod, ctx, pi.arg_t, Value.type);
        check_type_constructor_t(mod, Ctx.extend(ctx, pi.name, Exp.evaluate(mod, Ctx.to_env(ctx), pi.arg_t)), pi.ret_t);
        return;
    }
    if (t.kind === "Exp.type") {
        return;
    }
    throw new Trace.Trace("the t should be pi or type");
}
