export declare const zero_or_more: {
    $fn: (string | {
        "zero_or_more:zero": never[];
        "zero_or_more:more": ({
            head: string;
            tail?: undefined;
        } | {
            tail: {
                $ap: string[];
            };
            head?: undefined;
        })[];
    })[];
};
export declare const one_or_more: {
    $fn: (string | {
        "one_or_more:one": {
            value: string;
        }[];
        "one_or_more:more": ({
            head: string;
            tail?: undefined;
        } | {
            tail: {
                $ap: string[];
            };
            head?: undefined;
        })[];
    })[];
};
export declare const dashline: {
    "dashline:dashline": (string | {
        $ap: string[];
    })[];
};
export declare const $start = "exp";
export declare const identifier: {
    $pattern: string[];
};
export declare const exp: {
    "exp:var": {
        name: string;
    }[];
    "exp:pi": (string | {
        name: string;
        arg_t?: undefined;
        ret_t?: undefined;
    } | {
        arg_t: string;
        name?: undefined;
        ret_t?: undefined;
    } | {
        ret_t: string;
        name?: undefined;
        arg_t?: undefined;
    })[];
    "exp:arrow": (string | {
        arg_t: string;
        ret_t?: undefined;
    } | {
        ret_t: string;
        arg_t?: undefined;
    })[];
    "exp:fn": (string | {
        pattern: string;
        ret?: undefined;
    } | {
        ret: string;
        pattern?: undefined;
    })[];
    "exp:case_fn": (string | {
        cases: string;
    })[];
    "exp:ap": ({
        target: string;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        target?: undefined;
    })[];
    "exp:cls": (string | {
        sat: string;
        scope?: undefined;
    } | {
        scope: string;
        sat?: undefined;
    })[];
    "exp:obj": (string | {
        properties: string;
    })[];
    "exp:field": (string | {
        target: string;
        name?: undefined;
    } | {
        name: string;
        target?: undefined;
    })[];
    "exp:method": (string | {
        target: string;
        name?: undefined;
        args?: undefined;
    } | {
        name: string;
        target?: undefined;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        target?: undefined;
        name?: undefined;
    })[];
    "exp:equal": (string | {
        t: string;
        from?: undefined;
        to?: undefined;
    } | {
        from: string;
        t?: undefined;
        to?: undefined;
    } | {
        to: string;
        t?: undefined;
        from?: undefined;
    })[];
    "exp:same": string[];
    "exp:replace": (string | {
        target: string;
        motive?: undefined;
        base?: undefined;
    } | {
        motive: string;
        target?: undefined;
        base?: undefined;
    } | {
        base: string;
        target?: undefined;
        motive?: undefined;
    })[];
    "exp:absurd": string[];
    "exp:absurd_ind": (string | {
        target: string;
        motive?: undefined;
    } | {
        motive: string;
        target?: undefined;
    })[];
    "exp:str": string[];
    "exp:quote": {
        value: {
            $pattern: string[];
        };
    }[];
    "exp:union": (string | {
        head: string;
        tail?: undefined;
    } | {
        tail: {
            $ap: string[];
        };
        head?: undefined;
    })[];
    "exp:type": string[];
    "exp:object": string[];
    "exp:begin": (string | {
        stmts: string;
        ret?: undefined;
    } | {
        ret: string;
        stmts?: undefined;
    })[];
    "exp:deduction": (string | {
        deduction_entries: {
            $ap: string[];
        };
        deduction_args?: undefined;
    } | {
        deduction_args: {
            $ap: string[];
        };
        deduction_entries?: undefined;
    })[];
};
export declare const head: {
    "head:var": {
        name: string;
    }[];
    "head:ap": ({
        target: string;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        target?: undefined;
    })[];
    "head:field": (string | {
        target: string;
        name?: undefined;
    } | {
        name: string;
        target?: undefined;
    })[];
    "head:method": (string | {
        target: string;
        name?: undefined;
        args?: undefined;
    } | {
        name: string;
        target?: undefined;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        target?: undefined;
        name?: undefined;
    })[];
};
export declare const cases: {
    "cases:cases": {
        cases: {
            $ap: string[];
        };
    }[];
};
export declare const case_entry: {
    "case_entry:case_entry": (string | {
        pattern: string;
        ret?: undefined;
    } | {
        ret: string;
        pattern?: undefined;
    })[];
};
export declare const pattern: {
    "pattern:v": {
        name: string;
    }[];
    "pattern:datatype": ({
        name: string;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        name?: undefined;
    })[];
    "pattern:data": (string | {
        name: string;
        tag?: undefined;
        args?: undefined;
    } | {
        tag: string;
        name?: undefined;
        args?: undefined;
    } | {
        args: {
            $ap: string[];
        };
        name?: undefined;
        tag?: undefined;
    })[];
    "pattern:data_nullary": (string | {
        name: string;
        tag?: undefined;
    } | {
        tag: string;
        name?: undefined;
    })[];
};
export declare const deduction_entry: {
    "deduction_entry:deduction_entry": (string | {
        t: string;
        exp?: undefined;
    } | {
        exp: string;
        t?: undefined;
    })[];
};
export declare const tops: {
    "tops:tops": {
        tops: {
            $ap: string[];
        };
    }[];
};
export declare const top: {
    "top:def": (string | {
        name: string;
        exp?: undefined;
    } | {
        exp: string;
        name?: undefined;
    })[];
    "top:claim": (string | {
        claim: string;
        t?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        t: string;
        claim?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        define: string;
        claim?: undefined;
        t?: undefined;
        exp?: undefined;
    } | {
        exp: string;
        claim?: undefined;
        t?: undefined;
        define?: undefined;
    })[];
    "top:show": (string | {
        exp: string;
    })[];
    "top:datatype": (string | {
        name: string;
        t?: undefined;
        sums?: undefined;
    } | {
        t: string;
        name?: undefined;
        sums?: undefined;
    } | {
        sums: string;
        name?: undefined;
        t?: undefined;
    })[];
};
export declare const sums: {
    "sums:sums": {
        sums: {
            $ap: string[];
        };
    }[];
};
export declare const sum_entry: {
    "sum_entry:sum_entry": (string | {
        tag: string;
        t?: undefined;
    } | {
        t: string;
        tag?: undefined;
    })[];
};
export declare const stmts: {
    "stmts:stmts": {
        stmts: {
            $ap: string[];
        };
    }[];
};
export declare const stmt: {
    "stmt:def": (string | {
        name: string;
        exp?: undefined;
    } | {
        exp: string;
        name?: undefined;
    })[];
    "stmt:claim": (string | {
        claim: string;
        t?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        t: string;
        claim?: undefined;
        define?: undefined;
        exp?: undefined;
    } | {
        define: string;
        claim?: undefined;
        t?: undefined;
        exp?: undefined;
    } | {
        exp: string;
        claim?: undefined;
        t?: undefined;
        define?: undefined;
    })[];
};
export declare const properties: {
    "properties:properties": {
        properties: {
            $ap: string[];
        };
    }[];
};
export declare const property: {
    "property:property": (string | {
        name: string;
        exp?: undefined;
    } | {
        exp: string;
        name?: undefined;
    })[];
};
export declare const sat: {
    "sat:sat": {
        entries: {
            $ap: string[];
        };
    }[];
};
export declare const sat_entry: {
    "sat_entry:sat_entry": (string | {
        name: string;
        t?: undefined;
        exp?: undefined;
    } | {
        t: string;
        name?: undefined;
        exp?: undefined;
    } | {
        exp: string;
        name?: undefined;
        t?: undefined;
    })[];
};
export declare const scope: {
    "scope:scope": {
        entries: {
            $ap: string[];
        };
    }[];
};
export declare const scope_entry: {
    "scope_entry:scope_entry": (string | {
        name: string;
        t?: undefined;
    } | {
        t: string;
        name?: undefined;
    })[];
};
