"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.scope_entry = exports.scope = exports.sat_entry = exports.sat = exports.property = exports.properties = exports.stmt = exports.stmts = exports.sum_entry = exports.sums = exports.top = exports.tops = exports.deduction_entry = exports.pattern = exports.case_entry = exports.cases = exports.head = exports.exp = exports.identifier = exports.$start = exports.dashline = exports.one_or_more = exports.zero_or_more = void 0;
const pt = __importStar(require("../../partech"));
exports.zero_or_more = pt.grammars.zero_or_more;
exports.one_or_more = pt.grammars.one_or_more;
exports.dashline = pt.grammars.dashline;
exports.$start = "exp";
const preserved = [
    "Equal",
    "same",
    "replace",
    "Absurd",
    "String",
    "Type",
    "Object",
];
exports.identifier = {
    $pattern: ["identifier", `^(?!(${preserved.join("|")}))`],
};
exports.exp = {
    "exp:var": [{ name: "identifier" }],
    "exp:pi": [
        '"("',
        { name: "identifier" },
        '":"',
        { arg_t: "exp" },
        '")"',
        '"-"',
        '">"',
        { ret_t: "exp" },
    ],
    "exp:arrow": ['"("', { arg_t: "exp" }, '")"', '"-"', '">"', { ret_t: "exp" }],
    "exp:fn": [
        '"("',
        { pattern: "pattern" },
        '")"',
        '"="',
        '">"',
        { ret: "exp" },
    ],
    "exp:case_fn": ['"{"', { cases: "cases" }, '"}"'],
    "exp:ap": [
        { target: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
    "exp:cls": ['"{"', { sat: "sat" }, { scope: "scope" }, '"}"'],
    "exp:obj": ['"{"', { properties: "properties" }, '"}"'],
    "exp:field": [{ target: "head" }, '"."', { name: "identifier" }],
    "exp:method": [
        { target: "head" },
        '"."',
        { name: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
    "exp:equal": [
        '"Equal"',
        '"("',
        { t: "exp" },
        '","',
        { from: "exp" },
        '","',
        { to: "exp" },
        '")"',
    ],
    "exp:same": ['"same"'],
    "exp:replace": [
        '"replace"',
        '"("',
        { target: "exp" },
        '","',
        { motive: "exp" },
        '","',
        { base: "exp" },
        '")"',
    ],
    "exp:absurd": ['"Absurd"'],
    "exp:absurd_ind": [
        '"Absurd"',
        '"."',
        '"ind"',
        '"("',
        { target: "exp" },
        '","',
        { motive: "exp" },
        '")"',
    ],
    "exp:str": ['"String"'],
    "exp:quote": [{ value: { $pattern: ["string"] } }],
    "exp:union": [
        '"{"',
        { head: "exp" },
        { tail: { $ap: ["zero_or_more", '"|"', "exp"] } },
        '"}"',
    ],
    "exp:type": ['"Type"'],
    "exp:object": ['"Object"'],
    "exp:begin": [
        '"@"',
        '"begin"',
        '"{"',
        { stmts: "stmts" },
        { ret: "exp" },
        '"}"',
    ],
    "exp:deduction": [
        '"{"',
        { deduction_entries: { $ap: ["one_or_more", "deduction_entry"] } },
        { deduction_args: { $ap: ["zero_or_more", "exp"] } },
        '"}"',
    ],
};
exports.head = {
    "head:var": [{ name: "identifier" }],
    "head:ap": [
        { target: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
    "head:field": [{ target: "head" }, '"."', { name: "identifier" }],
    "head:method": [
        { target: "head" },
        '"."',
        { name: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
    ],
};
exports.cases = {
    "cases:cases": [{ cases: { $ap: ["one_or_more", "case_entry"] } }],
};
exports.case_entry = {
    "case_entry:case_entry": [
        '"("',
        { pattern: "pattern" },
        '")"',
        '"="',
        '">"',
        { ret: "exp" },
    ],
};
exports.pattern = {
    "pattern:v": [{ name: "identifier" }],
    "pattern:datatype": [
        { name: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "pattern", '")"'] } },
    ],
    "pattern:data": [
        { name: "identifier" },
        '"."',
        { tag: "identifier" },
        { args: { $ap: ["one_or_more", '"("', "pattern", '")"'] } },
    ],
    "pattern:data_nullary": [
        { name: "identifier" },
        '"."',
        { tag: "identifier" },
    ],
};
exports.deduction_entry = {
    "deduction_entry:deduction_entry": [{ t: "exp" }, "dashline", { exp: "exp" }],
};
exports.tops = {
    "tops:tops": [{ tops: { $ap: ["zero_or_more", "top"] } }],
};
exports.top = {
    "top:def": [{ name: "identifier" }, '"="', { exp: "exp" }],
    "top:claim": [
        { claim: "identifier" },
        '":"',
        { t: "exp" },
        { define: "identifier" },
        '"="',
        { exp: "exp" },
    ],
    "top:show": ['"@"', '"show"', { exp: "exp" }],
    "top:datatype": [
        '"@"',
        '"datatype"',
        { name: "identifier" },
        '":"',
        { t: "exp" },
        '"{"',
        { sums: "sums" },
        '"}"',
    ],
};
exports.sums = {
    "sums:sums": [{ sums: { $ap: ["zero_or_more", "sum_entry"] } }],
};
exports.sum_entry = {
    "sum_entry:sum_entry": [{ tag: "identifier" }, '":"', { t: "exp" }],
};
exports.stmts = {
    "stmts:stmts": [{ stmts: { $ap: ["zero_or_more", "stmt"] } }],
};
exports.stmt = {
    "stmt:def": [{ name: "identifier" }, '"="', { exp: "exp" }],
    "stmt:claim": [
        { claim: "identifier" },
        '":"',
        { t: "exp" },
        { define: "identifier" },
        '"="',
        { exp: "exp" },
    ],
};
exports.properties = {
    "properties:properties": [
        { properties: { $ap: ["zero_or_more", "property"] } },
    ],
};
exports.property = {
    "property:property": [{ name: "identifier" }, '"="', { exp: "exp" }],
};
exports.sat = {
    "sat:sat": [{ entries: { $ap: ["zero_or_more", "sat_entry"] } }],
};
exports.sat_entry = {
    "sat_entry:sat_entry": [
        { name: "identifier" },
        '":"',
        { t: "exp" },
        '"="',
        { exp: "exp" },
    ],
};
exports.scope = {
    "scope:scope": [{ entries: { $ap: ["one_or_more", "scope_entry"] } }],
};
exports.scope_entry = {
    "scope_entry:scope_entry": [{ name: "identifier" }, '":"', { t: "exp" }],
};
