"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.match = void 0;
const Env = __importStar(require("../env"));
const ut = __importStar(require("../../ut"));
function match(env, pattern, value) {
    return match_pattern(env, pattern, value, new Map());
}
exports.match = match;
// NOTE side effect on `matched`
function match_pattern(env, pattern, value, matched) {
    if (pattern.kind === "Pattern.v") {
        const found = matched.get(pattern.name);
        if (found === undefined) {
            matched.set(pattern.name, value);
            return Env.extend(env, pattern.name, value);
        }
        // NOTE not `Value.conversion()` because we do not have `ctx`
        if (ut.equal(found, value))
            return env;
        return undefined;
    }
    if (pattern.kind === "Pattern.datatype" &&
        value.kind === "Value.datatype" &&
        value.type_constructor.name === pattern.name) {
        return match_patterns(env, pattern.args, value.args, matched);
    }
    if (pattern.kind === "Pattern.data" &&
        value.kind === "Value.data" &&
        value.data_constructor.type_constructor.name === pattern.name &&
        value.data_constructor.tag === pattern.tag) {
        return match_patterns(env, pattern.args, value.args, matched);
    }
    if (pattern.kind === "Pattern.data" &&
        value.kind === "Value.data_constructor" &&
        value.type_constructor.name === pattern.name &&
        value.tag === pattern.tag) {
        return match_patterns(env, pattern.args, [], matched);
    }
    return undefined;
}
// NOTE side effect on `matched`
function match_patterns(env, patterns, values, matched) {
    if (patterns.length !== values.length)
        return undefined;
    let result_env = env;
    for (let i = 0; i < patterns.length; i++) {
        result_env = match_pattern(result_env, patterns[i], values[i], matched);
        if (result_env === undefined)
            return undefined;
    }
    return result_env;
}
