"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const Mod = __importStar(require("../mod"));
const Ctx = __importStar(require("../ctx"));
const Env = __importStar(require("../env"));
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
function run(mod, tops) {
    define(mod, tops);
    check(mod, tops);
    show(mod, tops);
}
exports.run = run;
function define(mod, tops) {
    for (const top of tops) {
        if (top.kind === "Top.def") {
            Mod.update(mod, top.name, { den: Mod.Den.def(top.exp, top.t) });
        }
        if (top.kind === "Top.type_constructor") {
            Mod.update(mod, top.type_constructor.name, {
                den: Mod.Den.type_constructor(top.type_constructor),
            });
        }
    }
}
function check(mod, tops) {
    for (const top of tops) {
        if (top.kind === "Top.def") {
            const t = Mod.lookup_type(mod, top.name);
            const ctx = Ctx.extend(Ctx.init(), top.name, t);
            Exp.check(mod, ctx, top.exp, t);
        }
        if (top.kind === "Top.type_constructor") {
            Exp.infer(mod, Ctx.init(), top.type_constructor);
        }
    }
}
function show(mod, tops) {
    for (const top of tops) {
        if (top.kind === "Top.show") {
            const env = Env.init();
            const ctx = Ctx.init();
            const t = Exp.infer(mod, ctx, top.exp);
            const value = Exp.evaluate(mod, env, top.exp);
            const value_repr = Exp.repr(Value.readback(mod, ctx, t, value));
            console.log(`${value_repr}`);
        }
    }
}
