"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dot = void 0;
const Env = __importStar(require("../../env"));
const Exp = __importStar(require("../../exp"));
const Value = __importStar(require("../../value"));
const Neutral = __importStar(require("../../neutral"));
const Trace = __importStar(require("../../../trace"));
const ut = __importStar(require("../../../ut"));
function dot(tel, name) {
    const { next, scope } = tel;
    let { mod, env } = tel;
    env = Env.clone(env);
    const value = loop(mod, env, next, scope, name);
    if (value === undefined) {
        throw new Trace.Trace(ut.aline(`
      |I can not find the name in the telescope.
      |- name: ${name}
      |- telescope: ${ut.inspect(tel)}
      |`));
    }
    return value;
}
exports.dot = dot;
function loop(mod, env, next, scope, name) {
    if (next === undefined) {
        return undefined;
    }
    if (next.name === name) {
        return next.t;
    }
    const next_value = Value.not_yet(next.t, Neutral.v(next.name));
    env = Env.update(env, next.name, next_value);
    const [entry, ...rest] = scope;
    const t = Exp.evaluate(mod, env, entry.t);
    next = { name: entry.name, t };
    return loop(mod, env, next, rest, name);
}
