"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fill = void 0;
const Telescope = __importStar(require("../telescope"));
const Env = __importStar(require("../../env"));
const Exp = __importStar(require("../../exp"));
const Trace = __importStar(require("../../../trace"));
const ut = __importStar(require("../../../ut"));
function fill(tel, value) {
    let { mod, env, next, scope } = tel;
    if (next === undefined) {
        throw new Trace.Trace(ut.aline(`
        |Filling fulled telescope.
        |- telescope: ${ut.inspect(tel)}
        |- value: ${ut.inspect(value)}
        |`));
    }
    env = Env.extend(env, next.name, value);
    const [entry, ...rest] = scope;
    if (entry === undefined) {
        return Telescope.create(mod, env, undefined, rest);
    }
    else {
        const t = Exp.evaluate(mod, env, entry.t);
        return Telescope.create(mod, env, { name: entry.name, t }, rest);
    }
}
exports.fill = fill;
