"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readback_cls = void 0;
const Value = __importStar(require("../value"));
const Neutral = __importStar(require("../neutral"));
const Exp = __importStar(require("../exp"));
const Ctx = __importStar(require("../ctx"));
const Env = __importStar(require("../env"));
const Mod = __importStar(require("../mod"));
function readback_cls(mod, ctx, cls) {
    ctx = Ctx.clone(ctx);
    // NOTE side-effect on ctx
    const norm_sat = readback_sat(mod, ctx, cls.sat);
    // NOTE `tel` has its own `tel.mod`
    const norm_scope = readback_scope(ctx, cls.tel);
    return Exp.cls(norm_sat, norm_scope);
}
exports.readback_cls = readback_cls;
function readback_sat(mod, ctx, sat) {
    const norm_sat = new Array();
    for (const entry of sat) {
        const name = entry.name;
        const t = Value.readback(mod, ctx, Value.type, entry.t);
        const exp = Value.readback(mod, ctx, entry.t, entry.value);
        norm_sat.push({ name, t, exp });
        Ctx.update(ctx, name, entry.t, entry.value);
    }
    return norm_sat;
}
function readback_scope(ctx, tel) {
    const norm_scope = new Array();
    const env = Env.clone(tel.env);
    if (tel.next !== undefined) {
        const name = tel.next.name;
        const t = Value.readback(tel.mod, ctx, Value.type, tel.next.t);
        norm_scope.push({ name, t });
        Ctx.update(ctx, name, tel.next.t);
        Env.update(env, name, Value.not_yet(tel.next.t, Neutral.v(name)));
    }
    for (const entry of tel.scope) {
        const name = entry.name;
        const mod = Mod.clone(tel.mod);
        const t_value = Exp.evaluate(mod, env, entry.t, {
            mode: Exp.EvaluationMode.mute_recursive_exp_in_mod,
        });
        const t = Value.readback(mod, ctx, Value.type, t_value);
        norm_scope.push({ name, t });
        Ctx.update(ctx, name, t_value);
        Env.update(env, name, Value.not_yet(t_value, Neutral.v(name)));
    }
    return norm_scope;
}
