"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readback_obj = void 0;
const Value = __importStar(require("../value"));
const Exp = __importStar(require("../exp"));
const Env = __importStar(require("../env"));
const Trace = __importStar(require("../../trace"));
function readback_obj(mod, ctx, cls, value) {
    // NOTE η-expanded every value with cls type to obj.
    const properties = new Map();
    readback_properties_from_sat(mod, ctx, properties, cls.sat, value);
    readback_properties_from_tel(mod, ctx, properties, cls.tel, value);
    return Exp.obj(properties);
}
exports.readback_obj = readback_obj;
function readback_properties_from_sat(mod, ctx, properties, sat, value) {
    for (const entry of sat) {
        const name = entry.name;
        const property_t = entry.t;
        const property_value = Exp.do_dot(value, name);
        if (!Value.conversion(mod, ctx, property_t, property_value, entry.value)) {
            throw new Trace.Trace("property_value not equivalent to entry.value");
        }
        const property_exp = Value.readback(mod, ctx, property_t, property_value);
        properties.set(name, property_exp);
        // NOTE no env update here, use the name already in env
    }
}
function readback_properties_from_tel(mod, ctx, properties, tel, value) {
    const env = Env.clone(tel.env);
    if (tel.next !== undefined) {
        const name = tel.next.name;
        const property_t = tel.next.t;
        const property_value = Exp.do_dot(value, name);
        const property_exp = Value.readback(mod, ctx, property_t, property_value);
        properties.set(name, property_exp);
        Env.update(env, name, property_value);
    }
    for (const entry of tel.scope) {
        const name = entry.name;
        const property_t = Exp.evaluate(mod, env, entry.t);
        const property_value = Exp.do_dot(value, name);
        const property_exp = Value.readback(mod, ctx, property_t, property_value);
        properties.set(name, property_exp);
        Env.update(env, name, property_value);
    }
}
