"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readback_type = void 0;
const Value = __importStar(require("../value"));
const Neutral = __importStar(require("../neutral"));
const Exp = __importStar(require("../exp"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
const value_readback_cls_1 = require("./value-readback-cls");
const value_readback_pi_1 = require("./value-readback-pi");
function readback_type(mod, ctx, value) {
    if (value.kind === "Value.str")
        return Exp.str;
    if (value.kind === "Value.quote")
        return Exp.quote(value.str);
    if (value.kind === "Value.absurd")
        return Exp.absurd;
    if (value.kind === "Value.equal")
        return Exp.equal(Value.readback(mod, ctx, Value.type, value.t), Value.readback(mod, ctx, value.t, value.from), Value.readback(mod, ctx, value.t, value.to));
    if (value.kind === "Value.cls")
        return value_readback_cls_1.readback_cls(mod, ctx, value);
    if (value.kind === "Value.pi")
        return value_readback_pi_1.readback_pi(mod, ctx, value);
    if (value.kind === "Value.union")
        return Exp.union(Value.readback(mod, ctx, Value.type, value.left), Value.readback(mod, ctx, Value.type, value.right));
    if (value.kind === "Value.type")
        return Exp.type;
    if (value.kind === "Value.not_yet")
        // NOTE t and value.t are ignored here,
        //  maybe use them to debug.
        return Neutral.readback(mod, ctx, value.neutral);
    throw readback_type_error(value);
}
exports.readback_type = readback_type;
function readback_type_error(value) {
    return new Trace.Trace(ut.aline(`
      |I can not readback type value: ${ut.inspect(value.kind)},
      |`));
}
