"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readback = void 0;
const Neutral = __importStar(require("../neutral"));
const Exp = __importStar(require("../exp"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
const value_readback_union_1 = require("./value-readback-union");
const value_readback_fn_1 = require("./value-readback-fn");
const value_readback_case_fn_1 = require("./value-readback-case-fn");
const value_readback_obj_1 = require("./value-readback-obj");
const value_readback_type_constructor_1 = require("./value-readback-type-constructor");
const value_readback_datatype_1 = require("./value-readback-datatype");
const value_readback_data_constructor_1 = require("./value-readback-data-constructor");
const value_readback_data_1 = require("./value-readback-data");
const value_readback_type_1 = require("./value-readback-type");
function readback(mod, ctx, t, value) {
    if (value.kind === "Value.type_constructor")
        return value_readback_type_constructor_1.readback_type_constructor(mod, ctx, t, value);
    if (value.kind === "Value.datatype")
        return value_readback_datatype_1.readback_datatype(mod, ctx, t, value);
    if (value.kind === "Value.data_constructor")
        return value_readback_data_constructor_1.readback_data_constructor(mod, ctx, t, value);
    if (value.kind === "Value.data")
        return value_readback_data_1.readback_data(mod, ctx, t, value);
    if (t.kind === "Value.union" && value.kind !== "Value.not_yet")
        return value_readback_union_1.readback_union(mod, ctx, t, value);
    if (t.kind === "Value.pi" && value.kind === "Value.case_fn")
        return value_readback_case_fn_1.readback_case_fn(mod, ctx, t, value);
    if (t.kind === "Value.pi")
        return value_readback_fn_1.readback_fn(mod, ctx, t, value);
    if (t.kind === "Value.cls")
        return value_readback_obj_1.readback_obj(mod, ctx, t, value);
    if (t.kind === "Value.absurd" &&
        value.kind === "Value.not_yet" &&
        value.t.kind === "Value.absurd")
        return Exp.the(Exp.absurd, Neutral.readback(mod, ctx, value.neutral));
    if (t.kind === "Value.equal" && value.kind === "Value.same")
        return Exp.same;
    if (t.kind === "Value.str" && value.kind === "Value.quote")
        return Exp.quote(value.str);
    if (t.kind === "Value.quote" &&
        value.kind === "Value.quote" &&
        value.str === t.str)
        return Exp.quote(value.str);
    if (t.kind === "Value.type")
        return value_readback_type_1.readback_type(mod, ctx, value);
    if (value.kind === "Value.not_yet")
        // NOTE t and value.t are ignored here,
        //  maybe use them to debug.
        return Neutral.readback(mod, ctx, value.neutral);
    throw readback_error(t, value);
}
exports.readback = readback;
function readback_error(t, value) {
    return new Trace.Trace(ut.aline(`
      |I can not readback value: ${ut.inspect(value.kind)},
      |of type: ${ut.inspect(t.kind)}.
      |`));
}
