"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.builder = exports.description = exports.command = void 0;
const TableLexer = __importStar(require("../../table-lexer"));
const lexers = __importStar(require("../../lexers"));
const ut = __importStar(require("../../../ut"));
const fs_1 = __importDefault(require("fs"));
exports.command = "lex <input>";
exports.description = "Lex text to tokens by table-lexer";
exports.builder = {
    output: { type: "string", alias: "o" },
    table: { type: "string" },
};
exports.handler = async (argv) => {
    const lexer = argv.table
        ? TableLexer.build(await ut.read_object(argv.table))
        : lexers.common;
    const text = await fs_1.default.promises.readFile(argv.input, "utf8");
    const tokens = lexer.lex(text);
    ut.write_object(tokens, argv.output);
};
