"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const Schedule = __importStar(require("./schedule"));
const Value = __importStar(require("../value"));
const ut = __importStar(require("../../ut"));
function create(grammar, opts = Schedule.DEFAULT_OPTS) {
    if (grammar.kind !== "Value.grammar") {
        throw new Error(`expecting grammar to be Value.grammar.\n` +
            `grammar: ${ut.inspect(Value.present(grammar))}\n`);
    }
    return {
        grammar,
        opts,
        // NOTE The phases of schedule:
        // create -> [init] -> run -> [finished]
        parse(tokens) {
            const schedule = Schedule.create(tokens, grammar);
            Schedule.run(schedule, opts);
            return Schedule.harvest(schedule);
        },
        recognize(tokens) {
            const schedule = Schedule.create(tokens, grammar);
            Schedule.run(schedule, opts);
            return Schedule.well_done_p(schedule);
        },
    };
}
exports.create = create;
