"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lexer = exports.parser = exports.grammar = exports.mod = void 0;
const EarleyParser = __importStar(require("../earley-parser"));
const TableLexer = __importStar(require("../table-lexer"));
const Mod = __importStar(require("../mod"));
const assert_1 = __importDefault(require("assert"));
const E = {
    "E:EQF": ["E", "Q", "F"],
    "E:F": ["F"],
};
const F = {
    "F:a": ['"a"'],
};
const Q = {
    "Q:+": ['"+"'],
    "Q:-": ['"-"'],
};
const one_or_more = {
    $fn: [
        "x",
        {
            "one_or_more:one": [{ value: "x" }],
            "one_or_more:more": [
                { head: "x" },
                { tail: { $ap: ["one_or_more", "x"] } },
            ],
        },
    ],
};
const S = {
    "S:S": [{ $ap: ["one_or_more", '"("', "E", '")"'] }],
};
exports.mod = Mod.build({ E, F, Q, one_or_more, S });
exports.grammar = Mod.dot(exports.mod, "S");
exports.parser = EarleyParser.create(exports.grammar);
exports.lexer = TableLexer.create([["char", /(.)/]]);
function ok(test) {
    assert_1.default(exports.parser.recognize(exports.lexer.lex(test)));
}
function oh(test) {
    assert_1.default(!exports.parser.recognize(exports.lexer.lex(test)));
}
ok("(a)");
ok("(a-a)");
ok("(a-a+a)");
ok("(a)(a)(a)");
ok("(a-a)(a-a)(a-a)");
ok("(a-a+a)(a-a+a)(a-a+a)");
ok("(a)(a-a)(a-a+a)");
oh("a");
oh("a-a");
oh("a-a+a");
oh("(a-a+a");
oh("(a-a+b)");
oh("(a-a++)");
oh("a-a+b");
oh("a-a++");
