"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.DEFAULT_OPTS = void 0;
const Schedule = __importStar(require("../schedule"));
const TaskQueue = __importStar(require("../task-queue"));
const FinishedChart = __importStar(require("../finished-chart"));
const Task = __importStar(require("../task"));
exports.DEFAULT_OPTS = {
    task: { verbose: false },
    schedule: { verbose: false },
};
function run(schedule, opts = exports.DEFAULT_OPTS) {
    while (true) {
        if (opts.schedule?.verbose) {
            console.log(Schedule.repr(schedule));
        }
        const task = TaskQueue.dequeue(schedule.queue);
        if (task === undefined)
            return;
        if (opts.task?.verbose) {
            console.log(Task.finished_p(task) ? "[resume from]:" : "   [stepping]:", Task.repr(task));
        }
        if (Task.finished_p(task)) {
            Schedule.resume(schedule, task);
            FinishedChart.insert(schedule.finished_chart, task);
        }
        else {
            Schedule.step(schedule, task);
            Schedule.leap(schedule, task);
        }
    }
}
exports.run = run;
