"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.start = void 0;
const Value = __importStar(require("../../value"));
function start(grammar_name, choice_name, parts, index) {
    return {
        grammar_name,
        choice_name,
        parts,
        index,
        progress: [],
        id_head: format_id_head(grammar_name, choice_name, parts, index),
        id_body: "",
    };
}
exports.start = start;
function format_id_head(grammar_name, choice_name, parts, index) {
    let s = grammar_name + ":" + choice_name + "@" + index + " -> ";
    for (let i = 0; i < parts.length; i++) {
        s += repr_part(parts[i]);
        s += " ";
    }
    return s;
}
function repr_part(part) {
    const { name, value } = part;
    const present = Value.present(value, { on_grammar: "only_show_name" });
    let s = "";
    if (typeof present === "string") {
        s += present.toString();
    }
    else if (present instanceof Array) {
        s += JSON.stringify(present);
    }
    else if (present.hasOwnProperty("$pattern")) {
        const [pattern_name] = present["$pattern"];
        s += pattern_name;
    }
    else {
        s += JSON.stringify(present);
    }
    return name ? repr_named(name, s) : s;
}
function repr_named(name, s) {
    return `(${name}: ${s})`;
}
