"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.equal_choices = exports.equal = void 0;
const Exp = __importStar(require("../exp"));
function equal(x, y) {
    if (x === y)
        return true;
    if (x.kind === "Exp.v" && y.kind === "Exp.v") {
        return x.name === y.name;
    }
    else if (x.kind === "Exp.fn" && y.kind === "Exp.fn") {
        return x.name === y.name && equal(x.ret, y.ret);
    }
    else if (x.kind === "Exp.ap" && y.kind === "Exp.ap") {
        return equal(x.target, y.target) && equal_exps(x.args, y.args);
    }
    else if (x.kind === "Exp.str" && y.kind === "Exp.str") {
        return x.value === y.value;
    }
    else if (x.kind === "Exp.pattern" && y.kind === "Exp.pattern") {
        return x.label === y.label && x.value.toString() === y.value.toString();
    }
    else if (x.kind === "Exp.grammar" && y.kind === "Exp.grammar") {
        return x.name === y.name && equal_choices(x.choices, y.choices);
    }
    else {
        return false;
    }
}
exports.equal = equal;
function equal_exps(x, y) {
    if (x === y)
        return true;
    if (x.length !== y.length)
        return false;
    for (let i = 0; i < x.length; i++) {
        if (!equal(x[i], y[i]))
            return false;
    }
    return true;
}
function equal_choices(x, y) {
    if (x === y)
        return true;
    if (x.size !== y.size)
        return false;
    for (const [key, x_part] of x.entries()) {
        const y_part = y.get(key);
        if (y_part === undefined)
            return false;
        if (!equal_parts(x_part, y_part))
            return false;
    }
    return true;
}
exports.equal_choices = equal_choices;
function equal_parts(x, y) {
    if (x === y)
        return true;
    if (x.length !== y.length)
        return false;
    for (let i = 0; i < x.length; i++) {
        if (x[i].name !== y[i].name)
            return false;
        if (!Exp.equal(x[i].value, y[i].value))
            return false;
    }
    return true;
}
