export declare type Exp = v | fn | ap | str | pattern | grammar;
interface v {
    kind: "Exp.v";
    name: string;
}
export declare const v: (name: string) => v;
interface fn {
    kind: "Exp.fn";
    name: string;
    ret: Exp;
}
export declare const fn: (name: string, ret: Exp) => fn;
interface ap {
    kind: "Exp.ap";
    target: Exp;
    args: Array<Exp>;
}
export declare const ap: (target: Exp, args: Array<Exp>) => ap;
interface str {
    kind: "Exp.str";
    value: string;
}
export declare const str: (value: string) => str;
interface pattern {
    kind: "Exp.pattern";
    label: string;
    value: RegExp;
}
export declare const pattern: (label: string, value: RegExp) => pattern;
interface grammar {
    kind: "Exp.grammar";
    name: string;
    choices: Map<string, Array<{
        name?: string;
        value: Exp;
    }>>;
}
export declare const grammar: (name: string, choices: Map<string, {
    name?: string | undefined;
    value: Exp;
}[]>) => grammar;
export {};
