"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.report = void 0;
const ut = __importStar(require("../../ut"));
const chalk_1 = __importDefault(require("chalk"));
function report(span, context) {
    let s = repr_in_context(span, context);
    s = decorate_line_number(s);
    s = line_span_focus(to_line_span_in_context(span, context), s, 3);
    return s;
}
exports.report = report;
function repr_in_context(span, context) {
    let s = "";
    for (let i = 0; i < context.length; i++) {
        if (span.lo <= i && i < span.hi) {
            s += chalk_1.default.bgRed(context.charAt(i));
        }
        else {
            s += context.charAt(i);
        }
    }
    // NOTE END_OF_FILE
    if (span.lo === context.length && span.hi === context.length) {
        s += chalk_1.default.bgRed(" ");
    }
    return s;
}
function decorate_line_number(text) {
    let lines = text.split("\n");
    let max = lines.length + 1;
    let width = max.toString().length;
    let decorated = "";
    lines.forEach((line, i) => {
        let line_number = i; // NOTE index from 0 instead of 1
        let line_number_string = line_number.toString();
        line_number_string =
            " ".repeat(width - line_number_string.length) + line_number_string;
        decorated += " ";
        decorated += line_number_string;
        decorated += " |";
        decorated += line;
        decorated += "\n";
    });
    return decorated;
}
function to_line_span_in_context(span, context) {
    let line_index_set = new Set();
    let cursor = 0;
    let lines = context.split("\n");
    for (let [i, line] of lines.entries()) {
        if (ut.interval_overlap_p(span.lo, span.hi, cursor, cursor + line.length + 1)) {
            line_index_set.add(i);
        }
        cursor += line.length + 1;
    }
    const lo = Math.min(...line_index_set);
    const hi = Math.max(...line_index_set);
    return { lo, hi };
}
function line_span_focus(span, context, margin) {
    let lines = context.split("\n");
    return lines.slice(Math.max(0, span.lo - margin), span.hi + margin).join("\n");
}
