"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.matcher = void 0;
const Tree = __importStar(require("../tree"));
const ut = __importStar(require("../../ut"));
function matcher(choices) {
    return (tree) => {
        if (tree.kind === "Tree.node") {
            const { body, head } = tree;
            const span = Tree.span(tree);
            const key = `${head.name}:${head.kind}`;
            const f = choices[key];
            if (f) {
                return f(body, { head, span });
            }
            else {
                throw new Error("Key mismatch.\n" +
                    `- key: ${key}\n` +
                    `- keys of choices: ${Object.keys(choices).join(", ")}\n`);
            }
        }
        else {
            throw new Error("Expecting Tree.node.\n" +
                `Tree.matcher can only match on node.\n` +
                `- tree: ${ut.inspect(tree)}\n`);
        }
    };
}
exports.matcher = matcher;
