"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Exp = __importStar(require("../exp"));
const Mod = __importStar(require("../mod"));
const Value = __importStar(require("../value"));
const mods = __importStar(require("../mods"));
const ut = __importStar(require("../../ut"));
function test(mod, env, exp_present, value_present, opts = { on_grammar: "as_exp" }) {
    const exp = Exp.build(exp_present);
    const values = Exp.evaluate(mod, env, exp);
    ut.assert_equal(values.length, 1);
    const value = values[0];
    ut.assert_equal(Value.present(value, opts), value_present);
}
{
    const mod = Mod.build(mods.exp);
    const env = new Map();
    // Exp.v
    test(mod, env, "exp", {
        "exp:var": [{ name: "identifier" }],
        "exp:fn": [
            '"("',
            { name: "identifier" },
            '")"',
            '"="',
            '">"',
            { body: "exp" },
        ],
        "exp:ap": [
            { head: "identifier" },
            { tail: { $ap: ["one_or_more", '"("', "exp", '")"'] } },
        ],
    }, { on_grammar: "as_exp" });
    // Exp.ap
    test(mod, env, { $ap: ["one_or_more", '"("', "exp", '")"'] }, {
        "one_or_more:one": [{ value: "x" }],
        "one_or_more:more": [
            { head: "x" },
            { tail: { $ap: ["one_or_more", "x"] } },
        ],
    }, { on_grammar: "as_exp" });
    test(mod, env, { $ap: ["one_or_more", '"("', "exp", '")"'] }, {
        "one_or_more:one": ['"("', { value: "exp" }, '")"'],
        "one_or_more:more": [
            '"("',
            { head: "exp" },
            '")"',
            { tail: "one_or_more" },
        ],
    }, { on_grammar: "force_one_step" });
}
