import * as Closure from "./closure";
import * as DelayedChoices from "./delayed-choices";
export declare type Value = fn | str | pattern | grammar;
interface fn {
    kind: "Value.fn";
    ret_cl: Closure.Closure;
}
export declare const fn: (ret_cl: Closure.Closure) => fn;
interface str {
    kind: "Value.str";
    value: string;
}
export declare const str: (value: string) => str;
interface pattern {
    kind: "Value.pattern";
    label: string;
    value: RegExp;
}
export declare const pattern: (label: string, value: RegExp) => pattern;
export interface grammar {
    kind: "Value.grammar";
    name: string;
    delayed: DelayedChoices.DelayedChoices;
}
export declare const grammar: (name: string, delayed: DelayedChoices.DelayedChoices) => grammar;
export {};
