"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.negative_lookbehind = exports.lookbehind = exports.negative_lookahead = exports.lookahead = void 0;
const create_regexp_1 = require("../create-regexp");
function lookahead(re, x) {
    re = create_regexp_1.create_regexp(re);
    x = create_regexp_1.create_regexp(x);
    return new RegExp(`${re.source}(?=${x.source})`);
}
exports.lookahead = lookahead;
function negative_lookahead(re, x) {
    re = create_regexp_1.create_regexp(re);
    x = create_regexp_1.create_regexp(x);
    return new RegExp(`${re.source}(?!${x.source})`);
}
exports.negative_lookahead = negative_lookahead;
function lookbehind(x, re) {
    re = create_regexp_1.create_regexp(re);
    x = create_regexp_1.create_regexp(x);
    return new RegExp(`(?<=${x.source})${re.source}`);
}
exports.lookbehind = lookbehind;
function negative_lookbehind(x, re) {
    re = create_regexp_1.create_regexp(re);
    x = create_regexp_1.create_regexp(x);
    return new RegExp(`(?<!${x.source})${re.source}`);
}
exports.negative_lookbehind = negative_lookbehind;
