"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.named_group = exports.non_capturing_group = exports.group = void 0;
const create_regexp_1 = require("../create-regexp");
function group(re) {
    re = create_regexp_1.create_regexp(re);
    return new RegExp(`(${re.source})`);
}
exports.group = group;
function non_capturing_group(re) {
    re = create_regexp_1.create_regexp(re);
    return new RegExp(`(?:${re.source})`);
}
exports.non_capturing_group = non_capturing_group;
function named_group(name, re) {
    re = create_regexp_1.create_regexp(re);
    return new RegExp(`(?<${name}>${re.source})`);
}
exports.named_group = named_group;
