"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const rr = __importStar(require("../index"));
const ut = __importStar(require("../../ut"));
// NOTE
//   https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions/Assertions
{
    // NOTE Lookahead assertion
    const re = rr.add_flag(rr.lookahead(/First/, / test/), rr.flags.global);
    assert_1.default(ut.equal("First test".match(re), ["First"]));
    assert_1.default(ut.equal("First peach".match(re), null));
    assert_1.default(ut.equal("This is a First test in a year.".match(re), ["First"]));
    assert_1.default(ut.equal("This is a First peach in a month.".match(re), null));
}
{
    // NOTE Basic negative lookahead assertion
    //   matches a number only if it is not followed by a decimal point.
    const re = rr.add_flag(rr.negative_lookahead(rr.one_or_more(rr.digit), /\./), rr.flags.global);
    assert_1.default(ut.equal("3.141".match(re), ["141"]));
}
{
    {
        // NOTE preserved identifiers
        //   with global flag
        const re = rr.add_flag(rr.seq(rr.negative_lookahead(rr.beginning, rr.or("type", "let", "case")), rr.word), rr.flags.global);
        assert_1.default(ut.equal("x".match(re), ["x"]));
        assert_1.default(ut.equal("y".match(re), ["y"]));
        assert_1.default(ut.equal("let".match(re), null));
        assert_1.default(ut.equal("type".match(re), null));
        assert_1.default(ut.equal("case".match(re), null));
        assert_1.default(ut.equal(re.exec("let"), null));
        assert_1.default(ut.equal(re.exec("type"), null));
        assert_1.default(ut.equal(re.exec("case"), null));
    }
    {
        const re = rr.seq(rr.negative_lookahead(rr.beginning, rr.or("type", "let", "case")), rr.word);
        {
            const result = "x".match(re);
            assert_1.default(ut.equal(result ? result[0] : null, "x"));
        }
        {
            const result = "y".match(re);
            assert_1.default(ut.equal(result ? result[0] : null, "y"));
        }
        assert_1.default(ut.equal("let".match(re), null));
        assert_1.default(ut.equal("type".match(re), null));
        assert_1.default(ut.equal("case".match(re), null));
        assert_1.default(ut.equal(re.exec("let"), null));
        assert_1.default(ut.equal(re.exec("type"), null));
        assert_1.default(ut.equal(re.exec("case"), null));
    }
}
{
    // NOTE Lookbehind assertion
    const oranges = ["ripe orange A ", "green orange B", "ripe orange C"];
    const re = rr.lookbehind("ripe ", "orange");
    const ripe_oranges = oranges.filter((fruit) => fruit.match(re));
    assert_1.default(ut.equal(ripe_oranges, ["ripe orange A ", "ripe orange C"]));
}
