"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const rr = __importStar(require("../index"));
const ut = __importStar(require("../../ut"));
// NOTE
//   https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions/Groups_and_Ranges
{
    const alice_excerpt = "The Caterpillar and Alice looked at each other";
    const without_e = rr.add_flag(rr.seq(rr.boundary, rr.one_or_more(/[a-df-z]/), rr.boundary), rr.flags.global + rr.flags.ignoreCase);
    assert_1.default(ut.equal(alice_excerpt.match(without_e), ["and", "at"]));
}
{
    const image_description = "This image has a resolution of 1440×900 pixels.";
    const digit = rr.group(rr.one_or_more(rr.digit));
    const size = rr.seq(digit, "×", digit);
    const results = size.exec(image_description);
    assert_1.default(results && results[1] === "1440");
    assert_1.default(results && results[2] === "900");
}
{
    // NOTE Counting vowels
    const alice_excerpt = "There was a long silence after this, and Alice could only hear whispers now and then.";
    const vowels = rr.add_flag(/[aeiouy]/, rr.flags.global);
    const results = alice_excerpt.match(vowels);
    assert_1.default(results && results.length === 25);
}
{
    // NOTE Using groups
    const persons = "first_name: John, last_name: Doe\n" +
        "first_name: Jane, last_name: Smith\n";
    const names = rr.add_flag(rr.seq("first_name: ", rr.group(rr.one_or_more(rr.word)), ", ", "last_name: ", rr.group(rr.one_or_more(rr.word))), rr.flags.global + rr.flags.multiline);
    {
        const results = names.exec(persons);
        if (results === null)
            throw new Error();
        const [_, first_name, last_name] = results;
        ut.assert_equal([first_name, last_name], ["John", "Doe"]);
    }
    {
        const results = names.exec(persons);
        if (results === null)
            throw new Error();
        const [_, first_name, last_name] = results;
        ut.assert_equal([first_name, last_name], ["Jane", "Smith"]);
    }
}
{
    // NOTE Using named groups
    const persons = "first_name: John, last_name: Doe\n" +
        "first_name: Jane, last_name: Smith\n";
    const names = rr.add_flag(rr.seq("first_name: ", rr.named_group("first_name", rr.one_or_more(rr.word)), ", ", "last_name: ", rr.named_group("last_name", rr.one_or_more(rr.word))), rr.flags.global + rr.flags.multiline);
    {
        const results = names.exec(persons);
        if (results && results.groups) {
            ut.assert_equal(results.groups.first_name, "John");
            ut.assert_equal(results.groups.last_name, "Doe");
        }
        else {
            throw new Error();
        }
    }
    {
        const results = names.exec(persons);
        if (results && results.groups) {
            ut.assert_equal(results.groups.first_name, "Jane");
            ut.assert_equal(results.groups.last_name, "Smith");
        }
        else {
            throw new Error();
        }
    }
}
