"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const rr = __importStar(require("../index"));
const ut = __importStar(require("../../ut"));
// NOTE
//   https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions/Quantifiers
{
    const ghost_speak = "booh boooooooh";
    const spooky = rr.seq(/b/, rr.at_least(3, /o/), /h/);
    const re = rr.add_flag(spooky, rr.flags.global);
    assert_1.default(ut.equal(ghost_speak.match(spooky), ["boooooooh"]));
}
{
    const modified_quote = "[He] ha[s] to go read this novel [Alice in Wonderland].";
    const non_greedy = rr.add_flag(rr.seq("[", rr.non_greedy(rr.zero_or_more(/./)), "]"), rr.flags.global);
    assert_1.default(ut.equal(modified_quote.match(non_greedy), [
        "[He]",
        "[s]",
        "[Alice in Wonderland]",
    ]));
    const greedy = rr.add_flag(rr.seq("[", rr.zero_or_more(/./), "]"), rr.flags.global);
    assert_1.default(ut.equal(modified_quote.match(greedy), [
        "[He] ha[s] to go read this novel [Alice in Wonderland]",
    ]));
}
{
    const xml = "<foo> <bar> new </bar> </foo>";
    const non_greedy = rr.add_flag(rr.seq(/</, rr.non_greedy(rr.zero_or_more(/./)), />/), rr.flags.global);
    assert_1.default(ut.equal(xml.match(non_greedy), ["<foo>", "<bar>", "</bar>", "</foo>"]));
    const greedy = rr.add_flag(rr.seq(/</, rr.zero_or_more(/./), />/), rr.flags.global);
    assert_1.default(ut.equal(xml.match(greedy), ["<foo> <bar> new </bar> </foo>"]));
}
{
    // NOTE Counting characters
    const single_letter_word = rr.add_flag(rr.seq(rr.boundary, rr.word, rr.boundary), rr.flags.global);
    const not_so_long_word = rr.add_flag(rr.seq(rr.boundary, rr.at_least_at_most(1, 6, rr.word), rr.boundary), rr.flags.global);
    const loooong_word = rr.add_flag(rr.seq(rr.boundary, rr.at_least(13, rr.word), rr.boundary), rr.flags.global);
    const sentence = "Why do I have to learn multiplication table?";
    assert_1.default(ut.equal(sentence.match(single_letter_word), ["I"]));
    assert_1.default(ut.equal(sentence.match(not_so_long_word), [
        "Why",
        "do",
        "I",
        "have",
        "to",
        "learn",
        "table",
    ]));
    assert_1.default(ut.equal(sentence.match(loooong_word), ["multiplication"]));
}
{
    // NOTE Optional character
    const british = "He asked his neighbour a favour.";
    const american = "He asked his neighbor a favor.";
    const ending = rr.add_flag(rr.seq(rr.one_or_more(rr.word), "o", rr.optional(/u/), "r"), rr.flags.global);
    assert_1.default(ut.equal(british.match(ending), ["neighbour", "favour"]));
    assert_1.default(ut.equal(american.match(ending), ["neighbor", "favor"]));
}
