"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.read_object = void 0;
const js_yaml_1 = __importDefault(require("js-yaml"));
const fs_1 = __importDefault(require("fs"));
async function read_object(file) {
    const text = await fs_1.default.promises.readFile(file, "utf8");
    if (file.endsWith(".yaml")) {
        // NOTE about YAML.JSON_SCHEMA
        //
        // https://yaml.org/spec/1.2/spec.html#id2803231
        return js_yaml_1.default.safeLoad(text, { schema: js_yaml_1.default.JSON_SCHEMA });
    }
    else if (file.endsWith(".json")) {
        return JSON.parse(text);
    }
    else {
        throw new Error(`Unknown file extension: ${file}.`);
    }
}
exports.read_object = read_object;
